<?php
/*
 * スマートフォン向け 簡易チャット
 * 
 * http://studio-key.com/
 * Copyright(c)2013 STUDIO KEY Allright reserved.
 * 
 */

session_start();

if(!$_POST) exit;

$max   = 50; //記録件数
$file  = '../data/chat.log';  //ログ記録ファイル
$admin = '管理人'; //管理人の名前

/*
 * チャットをファイルに書き込む
 */
function writeLog($str,$name,$color){
   global $file,$max;
   
   $bbsLog = file($file);
   $fp     = fopen($file,"w"); 
   flock($fp,2);
   $line = time().'<>'.$name.'<>'.$str."<>".date('Y/m/d H:i')."<>".$color."<>\n"; //最新ログを書き込む
   fputs($fp,$line);
   for($i=0; $i < count($bbsLog); $i++){ //既存ログを書き込む
      if( $i == $max) break; //指定件数になったら停止
      fputs($fp,$bbsLog[$i]);
   }
   flock($fp,3); 
   fclose($fp);
}


header("Content-type: application/xml");
echo '<?xml version="1.0" encoding="UTF-8" ?> ' . "\n";

/*
 * 全ログを取り出す
 * 
 */
if($_POST['type'] == 'log') {
   $bbsLog = file($file);
   $bbsLog = array_reverse($bbsLog);
   
?>
<rss>
<?php
   foreach( $bbsLog AS $row):
      $log = explode("<>",$row);
?>
  <item xml:space="preserve">
      <name><?php echo $log[1]; ?></name>
      <log><?php echo $log[2]; ?></log>
      <date><?php echo $log[3]; ?></date>
      <cr><?php echo $log[4]; ?></cr>
  </item>
<?php endforeach; ?>
</rss>

<?php
}

/*
 * 入室メッセージを記録する
 * 
 */
elseif($_POST['type'] == 'roomin') {
   $str = strip_tags($_POST['str']); //HTMLタグを除去
   $str = htmlspecialchars($str , ENT_QUOTES , "UTF-8"); // 特殊文字を HTML エンティティに変換する
   writeLog($str,$admin,'#666');
}
/*
 * 送信されたチャットをファイルに記録する
 * 
 */
else{
   $str = strip_tags($_POST['str']); //HTMLタグを除去
   $str = htmlspecialchars($str , ENT_QUOTES , "UTF-8"); // 特殊文字を HTML エンティティに変換する
   writeLog($str,$_COOKIE['CHAT_NAME'],$_COOKIE['CHAT_COLOR']);
?>
<rss>
  <item xml:space="preserve">
      <log><?php echo $str; ?></log>
      <name><?php echo $_COOKIE['CHAT_NAME']; ?></name>
  </item>
</rss>
<?php
exit;
}

?>